#include "botCntrlBase.h"

const int iCloseEnough = 50;
const int iDirectGrace = 10;

const int iDoNone = 0;
const int iDoL1 = 1;
const int iDoL2 = 2;
const int iDoR1 = 4;
const int iDoR2 = 5;


/*********************************************************************************
 */
void SeekLight::restarting()
{
  BotCntrlBase::restarting();
}

/*********************************************************************************
 */
void SeekLight::stopping()
{
}

/*********************************************************************************
 * Process the message as recieved from the controller (phone)
 */
void SeekLight::readSensors()
{
  int iLProx = !digitalRead(leftProxSensor);
  int iRProx = !digitalRead(rightProxSensor);
  
  if(iLProx || iRProx)
  {
    setCourseLeft(-200);
    setCourseRight(-200);
    ulLeftStart = ulLeftWheelCnt;
    ulRightStart = ulRightWheelCnt;
    if(iLProx)
    {
      iDoing = iDoL1;
    }
    else if(iRProx)
    {
      iDoing = iDoR1;
    }
  }
  
  unsigned long ulLDiff = ulLeftWheelCnt - ulLeftStart;
  unsigned long ulRDiff = ulRightWheelCnt - ulRightStart;
  switch(iDoing)
  {
  case iDoL1:
    if(ulLDiff + ulRDiff < 25)
    {
      setCourseLeft(200);
      setCourseRight(-200);
      return;
    }
    ulLeftStart = ulLeftWheelCnt;
    ulRightStart = ulRightWheelCnt;
    iDoing = iDoL2;
    return;
  case iDoL2:
  case iDoR2:
    if(ulLDiff + ulRDiff < 30)
    {
      setCourseLeft(200);
      setCourseRight(200);
      return;
    }
    ulLeftStart = ulLeftWheelCnt;
    ulRightStart = ulRightWheelCnt;
    iDoing = iDoNone;
    break;
  case iDoR1:
    if(ulLDiff + ulRDiff < 25)
    {
      setCourseLeft(-200);
      setCourseRight(200);
      return;
    }
    ulLeftStart = ulLeftWheelCnt;
    ulRightStart = ulRightWheelCnt;
    iDoing = iDoL2;
    return;
  }
  

  
  int iLF = analogRead(leftFrontLightSensor);
  int iRF = analogRead(rightFrontLightSensor);
  int iLB = analogRead(leftBackLightSensor);
  int iRB = analogRead(rightBackLightSensor);

  int iAvge = (iLF + iRF + iLB + iRB) / 4;
  if(abs(iAvge - iLF) < iCloseEnough && abs(iAvge - iRF) < iCloseEnough &&
     abs(iAvge - iLB) < iCloseEnough && abs(iAvge - iRB) < iCloseEnough)
  {
    // found what we are after
    setCourseLeft(0);
    setCourseRight(0);
  }

  int iF = max(iLF, iRF);
  int iB = max(iLB, iRB);

  if(iB > iF)
  {
    // light is brighter at the back
    if(iLB > iRB)
    {
      // turn to the left
      setCourseLeft(-255);
      setCourseRight(255);
    }
    else
    {
      // turn to the right
      setCourseLeft(255);
      setCourseRight(-255);
    }
  }
  else
  {
    iAvge = (iLF + iRF) / 2;

    // light is brighter at the front
    if(abs(iAvge - iLF) < iDirectGrace && abs(iAvge - iRF) < iDirectGrace)
    {
      // more forward
      setCourseLeft(200);
      setCourseRight(200);
    }
    else if(iLF > iRF)
    {
      // turn to the left
      setCourseLeft(-200);
      setCourseRight(200);
    }
    else
    {
      // turn to the right
      setCourseLeft(200);
      setCourseRight(-200);
    }
  }

}

